Botan: Botan::IF_Scheme_PrivateKey Class Reference

Botan 1.10.16

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
Botan::IF_Scheme_PrivateKey Class Referenceabstract

`#include <if_algo.h>`

Inheritance diagram for Botan::IF_Scheme_PrivateKey:

## Public Member Functions
virtual std::string | algo_name () const =0
AlgorithmIdentifier | algorithm_identifier () const
bool | check_key (RandomNumberGenerator &rng, bool) const
const BigInt & | get_c () const
const BigInt & | get_d () const
const BigInt & | get_d1 () const
const BigInt & | get_d2 () const
const BigInt & | get_e () const
const BigInt & | get_n () const
virtual OID | get_oid () const
const BigInt & | get_p () const
const BigInt & | get_q () const
| IF_Scheme_PrivateKey (RandomNumberGenerator &rng, const BigInt &prime1, const BigInt &prime2, const BigInt &exp, const BigInt &d_exp, const BigInt &mod)
| IF_Scheme_PrivateKey (RandomNumberGenerator &rng, const AlgorithmIdentifier &alg_id, const MemoryRegion< byte > &key_bits)
size_t | max_input_bits () const
virtual size_t | message_part_size () const
virtual size_t | message_parts () const
virtual AlgorithmIdentifier | pkcs8_algorithm_identifier () const
MemoryVector< byte > | pkcs8_private_key () const
MemoryVector< byte > | x509_subject_public_key () const

## Protected Member Functions
void | gen_check (RandomNumberGenerator &rng) const
| IF_Scheme_PrivateKey ()
virtual void | load_check (RandomNumberGenerator &rng) const
void | load_check (RandomNumberGenerator &rng) const

## Protected Attributes
BigInt | c
BigInt | d
BigInt | d1
BigInt | d2
BigInt | e
BigInt | n
BigInt | p
BigInt | q

## Detailed Description

This class represents public keys of integer factorization based (IF) public key schemes.

Definition at line 58 of file if_algo.h.

## Constructor & Destructor Documentation

## ◆ IF_Scheme_PrivateKey() [1/3]

Botan::IF_Scheme_PrivateKey::IF_Scheme_PrivateKey | ( | RandomNumberGenerator & | rng,
|  | const BigInt & | prime1,
|  | const BigInt & | prime2,
|  | const BigInt & | exp,
|  | const BigInt & | d_exp,
|  | const BigInt & | mod
| ) |  |

Definition at line 89 of file if_algo.cpp.

95 {
96 p = prime1;
97 q = prime2;
98 e = exp;
99 d = d_exp;
100 n = mod.is_nonzero() ? mod : p * q;
101
102 if(d == 0)
103 {
104 BigInt inv_for_d = lcm(p - 1, q - 1);
105 if(e.is_even())
106 inv_for_d >>= 1;
107
108 d = inverse_mod(e, inv_for_d);
109 }
110
111 d1 = d % (p - 1);
112 d2 = d % (q - 1);
113 c = inverse_mod(q, p);
114
115 load_check(rng);
116 }
Botan::IF_Scheme_PublicKey::n
BigInt n
Definition: if_algo.h:51
Botan::IF_Scheme_PrivateKey::d2
BigInt d2
Definition: if_algo.h:101
Botan::IF_Scheme_PublicKey::e
BigInt e
Definition: if_algo.h:51
Botan::BigInt::is_even
bool is_even() const
Definition: bigint.h:158
Botan::IF_Scheme_PrivateKey::d1
BigInt d1
Definition: if_algo.h:101
Botan::Private_Key::load_check
void load_check(RandomNumberGenerator &rng) const
Definition: pk_keys.cpp:40
Botan::IF_Scheme_PrivateKey::q
BigInt q
Definition: if_algo.h:101
Botan::inverse_mod
BigInt inverse_mod(const BigInt &n, const BigInt &mod)
Definition: numthry.cpp:314
Botan::IF_Scheme_PrivateKey::d
BigInt d
Definition: if_algo.h:101
Botan::IF_Scheme_PrivateKey::c
BigInt c
Definition: if_algo.h:101
Botan::lcm
BigInt lcm(const BigInt &a, const BigInt &b)
Definition: numthry.cpp:195
Botan::IF_Scheme_PrivateKey::p
BigInt p
Definition: if_algo.h:101

## ◆ IF_Scheme_PrivateKey() [2/3]

Botan::IF_Scheme_PrivateKey::IF_Scheme_PrivateKey | ( | RandomNumberGenerator & | rng,
|  | const AlgorithmIdentifier & | alg_id,
|  | const MemoryRegion< byte > & | key_bits
| ) |  |

Definition at line 69 of file if_algo.cpp.

72 {
73 BER_Decoder(key_bits)
74 .start_cons(SEQUENCE)
75 .decode_and_check<size_t>(0, "Unknown PKCS #1 key format version")
76 .decode(n)
77 .decode(e)
78 .decode(d)
79 .decode(p)
80 .decode(q)
81 .decode(d1)
82 .decode(d2)
83 .decode(c)
84 .end_cons();
85
86 load_check(rng);
87 }
Botan::IF_Scheme_PublicKey::n
BigInt n
Definition: if_algo.h:51
Botan::IF_Scheme_PrivateKey::d2
BigInt d2
Definition: if_algo.h:101
Botan::IF_Scheme_PublicKey::e
BigInt e
Definition: if_algo.h:51
Botan::PEM_Code::decode
SecureVector< byte > decode(DataSource &source, std::string &label)
Definition: pem.cpp:56
Botan::IF_Scheme_PrivateKey::d1
BigInt d1
Definition: if_algo.h:101
Botan::SEQUENCE
Definition: asn1_int.h:35
Botan::Private_Key::load_check
void load_check(RandomNumberGenerator &rng) const
Definition: pk_keys.cpp:40
Botan::IF_Scheme_PrivateKey::q
BigInt q
Definition: if_algo.h:101
Botan::IF_Scheme_PrivateKey::d
BigInt d
Definition: if_algo.h:101
Botan::IF_Scheme_PrivateKey::c
BigInt c
Definition: if_algo.h:101
Botan::IF_Scheme_PrivateKey::p
BigInt p
Definition: if_algo.h:101

## ◆ IF_Scheme_PrivateKey() [3/3]

Botan::IF_Scheme_PrivateKey::IF_Scheme_PrivateKey | ( |  | ) |
| inlineprotected

Definition at line 99 of file if_algo.h.

99 {}

## Member Function Documentation

## ◆ algo_name()

virtual std::string Botan::Public_Key::algo_name | ( |  | ) | const
| pure virtualinherited

Get the name of the underlying public key scheme.

Returns
  name of the public key scheme

Implemented in Botan::ECDSA_PublicKey, Botan::ECDH_PublicKey, Botan::ElGamal_PublicKey, Botan::DH_PublicKey, Botan::DSA_PublicKey, Botan::NR_PublicKey, Botan::RSA_PublicKey, and Botan::RW_PublicKey.

Referenced by Botan::EAC_Signed_Object::check_signature(), Botan::X509_Object::check_signature(), Botan::X509::find_constraints(), Botan::Public_Key::get_oid(), Botan::PK_Decryptor_EME::PK_Decryptor_EME(), Botan::PK_Encryptor_EME::PK_Encryptor_EME(), Botan::PK_Key_Agreement::PK_Key_Agreement(), Botan::PK_Signer::PK_Signer(), Botan::PK_Verifier::PK_Verifier(), Botan::CMS_Encoder::sign(), and Botan::Server_Key_Exchange::verify().

## ◆ algorithm_identifier()

AlgorithmIdentifier Botan::IF_Scheme_PublicKey::algorithm_identifier | ( |  | ) | const
| virtualinherited

Returns
  X.509 AlgorithmIdentifier for this key

Implements Botan::Public_Key.

Definition at line 15 of file if_algo.cpp.

References Botan::Public_Key::get_oid(), and Botan::AlgorithmIdentifier::USE_NULL_PARAM.

16 {
17 return AlgorithmIdentifier(get_oid(),
18 AlgorithmIdentifier::USE_NULL_PARAM);
19 }
Botan::Public_Key::get_oid
virtual OID get_oid() const
Definition: pk_keys.cpp:17
Botan::AlgorithmIdentifier::USE_NULL_PARAM
Definition: alg_id.h:23

## ◆ check_key()

bool Botan::IF_Scheme_PrivateKey::check_key | ( | RandomNumberGenerator & | rng,
|  | bool | strong
| ) |  | const
| virtual

Test the key values for consistency.

Parameters

  rng | rng to use
  strong | whether to perform strong and lengthy version of the test

Returns
  true if the test is passed

Reimplemented from Botan::IF_Scheme_PublicKey.

Reimplemented in Botan::RW_PrivateKey, and Botan::RSA_PrivateKey.

Definition at line 121 of file if_algo.cpp.

123 {
124 if(n < 35 || n.is_even() || e < 2 || d < 2 || p < 3 || q < 3 || p*q != n)
125 return false;
126
127 if(!strong)
128 return true;
129
130 if(d1 != d % (p - 1) || d2 != d % (q - 1) || c != inverse_mod(q, p))
131 return false;
132 if(!check_prime(p, rng) || !check_prime(q, rng))
133 return false;
134 return true;
135 }
Botan::IF_Scheme_PublicKey::n
BigInt n
Definition: if_algo.h:51
Botan::IF_Scheme_PrivateKey::d2
BigInt d2
Definition: if_algo.h:101
Botan::IF_Scheme_PublicKey::e
BigInt e
Definition: if_algo.h:51
Botan::BigInt::is_even
bool is_even() const
Definition: bigint.h:158
Botan::IF_Scheme_PrivateKey::d1
BigInt d1
Definition: if_algo.h:101
Botan::IF_Scheme_PrivateKey::q
BigInt q
Definition: if_algo.h:101
Botan::inverse_mod
BigInt inverse_mod(const BigInt &n, const BigInt &mod)
Definition: numthry.cpp:314
Botan::IF_Scheme_PrivateKey::d
BigInt d
Definition: if_algo.h:101
Botan::IF_Scheme_PrivateKey::c
BigInt c
Definition: if_algo.h:101
Botan::check_prime
bool check_prime(const BigInt &n, RandomNumberGenerator &rng)
Definition: numthry.h:143
Botan::IF_Scheme_PrivateKey::p
BigInt p
Definition: if_algo.h:101

## ◆ gen_check()

void Botan::Private_Key::gen_check | ( | RandomNumberGenerator & | rng | ) | const
| protectedinherited

Self-test after generating a key

Parameters

  rng | a random number generator

Definition at line 49 of file pk_keys.cpp.

50 {
51 if(!check_key(rng, BOTAN_PRIVATE_KEY_STRONG_CHECKS_ON_GENERATE))
52 throw Self_Test_Failure(algo_name() + " private key generation failed");
53 }
Botan::Public_Key::check_key
virtual bool check_key(RandomNumberGenerator &rng, bool strong) const =0
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0

## ◆ get_c()

const BigInt& Botan::IF_Scheme_PrivateKey::get_c | ( |  | ) | const
| inline

Definition at line 92 of file if_algo.h.

92 { return c; }
Botan::IF_Scheme_PrivateKey::c
BigInt c
Definition: if_algo.h:101

## ◆ get_d()

const BigInt& Botan::IF_Scheme_PrivateKey::get_d | ( |  | ) | const
| inline

Get d with exp * d = 1 mod (p - 1, q - 1).

Returns
  d

Definition at line 90 of file if_algo.h.

90 { return d; }
Botan::IF_Scheme_PrivateKey::d
BigInt d
Definition: if_algo.h:101

## ◆ get_d1()

const BigInt& Botan::IF_Scheme_PrivateKey::get_d1 | ( |  | ) | const
| inline

Definition at line 93 of file if_algo.h.

93 { return d1; }
Botan::IF_Scheme_PrivateKey::d1
BigInt d1
Definition: if_algo.h:101

## ◆ get_d2()

const BigInt& Botan::IF_Scheme_PrivateKey::get_d2 | ( |  | ) | const
| inline

Definition at line 94 of file if_algo.h.

94 { return d2; }
Botan::IF_Scheme_PrivateKey::d2
BigInt d2
Definition: if_algo.h:101

## ◆ get_e()

const BigInt& Botan::IF_Scheme_PublicKey::get_e | ( |  | ) | const
| inlineinherited

Returns
  public exponent

Definition at line 44 of file if_algo.h.

44 { return e; }
Botan::IF_Scheme_PublicKey::e
BigInt e
Definition: if_algo.h:51

## ◆ get_n()

const BigInt& Botan::IF_Scheme_PublicKey::get_n | ( |  | ) | const
| inlineinherited

Returns
  public modulus

Definition at line 39 of file if_algo.h.

39 { return n; }
Botan::IF_Scheme_PublicKey::n
BigInt n
Definition: if_algo.h:51

## ◆ get_oid()

OID Botan::Public_Key::get_oid | ( |  | ) | const
| virtualinherited

Get the OID of the underlying public key scheme.

Returns
  OID of the public key scheme

Definition at line 17 of file pk_keys.cpp.

References Botan::Public_Key::algo_name(), and Botan::OIDS::lookup().

Referenced by Botan::DL_Scheme_PublicKey::algorithm_identifier(), Botan::IF_Scheme_PublicKey::algorithm_identifier(), and Botan::EC_PublicKey::algorithm_identifier().

18 {
19 try {
20 return OIDS::lookup(algo_name());
21 }
22 catch(Lookup_Error)
23 {
24 throw Lookup_Error("PK algo " + algo_name() + " has no defined OIDs");
25 }
26 }
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0
Botan::OIDS::lookup
std::string lookup(const OID &oid)
Definition: oids.cpp:31

## ◆ get_p()

const BigInt& Botan::IF_Scheme_PrivateKey::get_p | ( |  | ) | const
| inline

Get the first prime p.

Returns
  prime p

Definition at line 78 of file if_algo.h.

78 { return p; }
Botan::IF_Scheme_PrivateKey::p
BigInt p
Definition: if_algo.h:101

## ◆ get_q()

const BigInt& Botan::IF_Scheme_PrivateKey::get_q | ( |  | ) | const
| inline

Get the second prime q.

Returns
  prime q

Definition at line 84 of file if_algo.h.

84 { return q; }
Botan::IF_Scheme_PrivateKey::q
BigInt q
Definition: if_algo.h:101

## ◆ load_check() [1/2]

void Botan::Public_Key::load_check | ( | RandomNumberGenerator & | rng | ) | const
| protectedvirtualinherited

Self-test after loading a key

Parameters

  rng | a random number generator

Reimplemented in Botan::Private_Key.

Definition at line 31 of file pk_keys.cpp.

32 {
33 if(!check_key(rng, BOTAN_PUBLIC_KEY_STRONG_CHECKS_ON_LOAD))
34 throw Invalid_Argument(algo_name() + ": Invalid public key");
35 }
Botan::Public_Key::check_key
virtual bool check_key(RandomNumberGenerator &rng, bool strong) const =0
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0
Botan::Invalid_Argument
std::invalid_argument Invalid_Argument
Definition: exceptn.h:20

## ◆ load_check() [2/2]

void Botan::Private_Key::load_check | ( | RandomNumberGenerator & | rng | ) | const
| protectedvirtualinherited

Self-test after loading a key

Parameters

  rng | a random number generator

Reimplemented from Botan::Public_Key.

Definition at line 40 of file pk_keys.cpp.

41 {
42 if(!check_key(rng, BOTAN_PRIVATE_KEY_STRONG_CHECKS_ON_LOAD))
43 throw Invalid_Argument(algo_name() + ": Invalid private key");
44 }
Botan::Public_Key::check_key
virtual bool check_key(RandomNumberGenerator &rng, bool strong) const =0
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0
Botan::Invalid_Argument
std::invalid_argument Invalid_Argument
Definition: exceptn.h:20

## ◆ max_input_bits()

size_t Botan::IF_Scheme_PublicKey::max_input_bits | ( |  | ) | const
| inlinevirtualinherited

Get the maximum message size in bits supported by this public key.

Returns
  maximum message size in bits

Implements Botan::Public_Key.

Definition at line 46 of file if_algo.h.

46 { return (n.bits() - 1); }
Botan::IF_Scheme_PublicKey::n
BigInt n
Definition: if_algo.h:51
Botan::BigInt::bits
size_t bits() const
Definition: bigint.cpp:253

## ◆ message_part_size()

virtual size_t Botan::Public_Key::message_part_size | ( |  | ) | const
| inlinevirtualinherited

Find out the message part size supported by this scheme/key.

Returns
  size of the message parts in bits

Reimplemented in Botan::ECDSA_PublicKey, Botan::NR_PublicKey, and Botan::DSA_PublicKey.

Definition at line 56 of file pk_keys.h.

56 { return 0; }

## ◆ message_parts()

virtual size_t Botan::Public_Key::message_parts | ( |  | ) | const
| inlinevirtualinherited

Find out the number of message parts supported by this scheme.

Returns
  number of message parts

Reimplemented in Botan::ECDSA_PublicKey, Botan::NR_PublicKey, and Botan::DSA_PublicKey.

Definition at line 50 of file pk_keys.h.

Referenced by Botan::EAC_Signed_Object::check_signature(), Botan::X509_Object::check_signature(), and Botan::X509_Store::validate_cert().

50 { return 1; }

## ◆ pkcs8_algorithm_identifier()

virtual AlgorithmIdentifier Botan::Private_Key::pkcs8_algorithm_identifier | ( |  | ) | const
| inlinevirtualinherited

Returns
  PKCS #8 AlgorithmIdentifier for this key Might be different from the X.509 identifier, but normally is not

Definition at line 98 of file pk_keys.h.

Referenced by Botan::PKCS8::BER_encode().

99 { return algorithm_identifier(); }
Botan::Public_Key::algorithm_identifier
virtual AlgorithmIdentifier algorithm_identifier() const =0

## ◆ pkcs8_private_key()

MemoryVector< byte > Botan::IF_Scheme_PrivateKey::pkcs8_private_key | ( |  | ) | const
| virtual

Returns
  PKCS #8 private key encoding for this key object

Implements Botan::Private_Key.

Definition at line 52 of file if_algo.cpp.

References Botan::IF_Scheme_PublicKey::e, Botan::DER_Encoder::encode(), Botan::DER_Encoder::end_cons(), Botan::DER_Encoder::get_contents(), Botan::IF_Scheme_PublicKey::n, Botan::SEQUENCE, and Botan::DER_Encoder::start_cons().

53 {
54 return DER_Encoder()
55 .start_cons(SEQUENCE)
56 .encode(static_cast<size_t>(0))
57 .encode(n)
58 .encode(e)
59 .encode(d)
60 .encode(p)
61 .encode(q)
62 .encode(d1)
63 .encode(d2)
64 .encode(c)
65 .end_cons()
66 .get_contents();
67 }
Botan::IF_Scheme_PublicKey::n
BigInt n
Definition: if_algo.h:51
Botan::IF_Scheme_PrivateKey::d2
BigInt d2
Definition: if_algo.h:101
Botan::IF_Scheme_PublicKey::e
BigInt e
Definition: if_algo.h:51
Botan::IF_Scheme_PrivateKey::d1
BigInt d1
Definition: if_algo.h:101
Botan::SEQUENCE
Definition: asn1_int.h:35
Botan::IF_Scheme_PrivateKey::q
BigInt q
Definition: if_algo.h:101
Botan::IF_Scheme_PrivateKey::d
BigInt d
Definition: if_algo.h:101
Botan::IF_Scheme_PrivateKey::c
BigInt c
Definition: if_algo.h:101
Botan::IF_Scheme_PrivateKey::p
BigInt p
Definition: if_algo.h:101

## ◆ x509_subject_public_key()

MemoryVector< byte > Botan::IF_Scheme_PublicKey::x509_subject_public_key | ( |  | ) | const
| virtualinherited

Returns
  X.509 subject key encoding for this key object

Implements Botan::Public_Key.

Definition at line 21 of file if_algo.cpp.

References Botan::IF_Scheme_PublicKey::e, Botan::DER_Encoder::encode(), Botan::DER_Encoder::end_cons(), Botan::DER_Encoder::get_contents(), Botan::IF_Scheme_PublicKey::n, Botan::SEQUENCE, and Botan::DER_Encoder::start_cons().

22 {
23 return DER_Encoder()
24 .start_cons(SEQUENCE)
25 .encode(n)
26 .encode(e)
27 .end_cons()
28 .get_contents();
29 }
Botan::IF_Scheme_PublicKey::n
BigInt n
Definition: if_algo.h:51
Botan::IF_Scheme_PublicKey::e
BigInt e
Definition: if_algo.h:51
Botan::SEQUENCE
Definition: asn1_int.h:35

## Member Data Documentation

## ◆ c

BigInt Botan::IF_Scheme_PrivateKey::c
| protected

Definition at line 101 of file if_algo.h.

## ◆ d

BigInt Botan::IF_Scheme_PrivateKey::d
| protected

Definition at line 101 of file if_algo.h.

## ◆ d1

BigInt Botan::IF_Scheme_PrivateKey::d1
| protected

Definition at line 101 of file if_algo.h.

## ◆ d2

BigInt Botan::IF_Scheme_PrivateKey::d2
| protected

Definition at line 101 of file if_algo.h.

## ◆ e

BigInt Botan::IF_Scheme_PublicKey::e
| protectedinherited

Definition at line 51 of file if_algo.h.

Referenced by Botan::IF_Scheme_PublicKey::check_key(), Botan::IF_Scheme_PublicKey::IF_Scheme_PublicKey(), pkcs8_private_key(), and Botan::IF_Scheme_PublicKey::x509_subject_public_key().

## ◆ n

BigInt Botan::IF_Scheme_PublicKey::n
| protectedinherited

Definition at line 51 of file if_algo.h.

Referenced by Botan::IF_Scheme_PublicKey::check_key(), Botan::IF_Scheme_PublicKey::IF_Scheme_PublicKey(), pkcs8_private_key(), and Botan::IF_Scheme_PublicKey::x509_subject_public_key().

## ◆ p

BigInt Botan::IF_Scheme_PrivateKey::p
| protected

Definition at line 101 of file if_algo.h.

## ◆ q

BigInt Botan::IF_Scheme_PrivateKey::q
| protected

Definition at line 101 of file if_algo.h.

The documentation for this class was generated from the following files:

- src/pubkey/if_algo/if_algo.h
- src/pubkey/if_algo/if_algo.cpp